unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Registry, ExtCtrls, RXSpin, ShellApi, RXCombos;

type
  TForm1 = class (TForm)
    Button1: TButton;
    Button2: TButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    FontComboBox1: TFontComboBox;
    RxSpinEdit1: TRxSpinEdit;
    Label2: TLabel;
    Label3: TLabel;
    GroupBox2: TGroupBox;
    Delphi2: TRadioButton;
    Delphi3: TRadioButton;
    Delphi4: TRadioButton;
    Delphi5: TRadioButton;
    Fett: TCheckBox;
    Kursiv: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Label2Click(Sender: TObject);
    procedure Delphi2Click(Sender: TObject);
    procedure Delphi3Click(Sender: TObject);
    procedure Delphi4Click(Sender: TObject);
    procedure Delphi5Click(Sender: TObject);
  private
    { Private-Deklarationen }
    procedure SetObjects (x: string);
    procedure ReadFromReg (v: string);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
{$i DateTime.inc}

const cpath = 'SOFTWARE\BORLAND\DELPHI\';

var p2, p3, p4, p5: string;

procedure KillBlanks(leading: BOOLEAN; var s: string);
// Kills leading or trailing blanks of a string
begin
 if leading then begin
  while (s[1] = ' ') and (Length(s) > 0) do Delete(s, 1, 1);
 end else begin
  while (s[Length(s)] = ' ') and (Length(s) > 0) do Delete(s, Length(s), 1);
 end;
end (*KillBlanks*);


procedure TForm1.Button1Click(Sender: TObject);
begin
 Application.Terminate;
end;

procedure TForm1.SetObjects (x: string);
// reads the default values and places them into the form
// x holds the values as read from the registry
var y: string;
    i, j: INTEGER;
begin
 // use default if no values are in x
 FontComboBox1.FontName:= 'MS Sans Serif';
 RxSpinEdit1.Value:= 8;
 Kursiv.Checked:= FALSE;
 Fett.Checked:= FALSE;
 if Length (x) > 1 then begin
  KillBlanks (TRUE, x);  // Kill leading Blanks
  KillBlanks (FALSE, x);  // Kill trailing Blanks
  i:= Pos (',', x);  // Looking for first comma
  if i = 0 then  y:= x  else  y:= Copy (x, 1, i-1);
  FontComboBox1.FontName:= y; // copy name
  Delete (x, 1, i); // delete name
  i:= 1; while (x[i] = ' ') or (x[i] = ',') do begin Delete (x, 1, 1); INC (i); end;

  i:= Pos (',', x);  // Looking for next comma
  if i = 0 then  y:= x  else  y:= Copy (x, 1, i-1);
  RxSpinEdit1.Value:= StrToInt (y); // Size
  Delete (x, 1, i); // delete size
  i:= 1; while (x[i] = ' ') or (x[i] = ',') do begin Delete (x, 1, 1); INC (i); end;

  i:= Pos (',', x); // Looking for next comma
  if i = 0 then  y:= x  else  y:= Copy (x, 1, i-1);
  for j:= 1 to Length (y) do  y[j]:= Upcase (y[j]);
  Fett.Checked:= y = 'BOLD';
  Kursiv.Checked:= y = 'ITALIC';
  Delete (x, 1, i); // delete
  i:= 1; while (x[i] = ' ') or (x[i] = ',') do begin Delete (x, 1, 1); INC (i); end;

  i:= Pos (',', x); // any other commas out there?
  if i = 0 then  y:= x  else  y:= Copy (x, 1, i-1);
  for j:= 1 to Length (y) do  y[j]:= Upcase (y[j]);
  if y = 'BOLD'   then  Fett.Checked:= TRUE;
  if y = 'ITALIC' then  Kursiv.Checked:= TRUE;
 end;
end (*SetObjects*);

procedure TForm1.ReadFromReg(v: string);
// Refreshes the values when a Radiobutton is clicked
var x: string;
    r: TRegistry;
begin
 r:= TRegistry.Create;
 try
  r.Rootkey:= HKEY_CURRENT_USER;
  if r.OpenKey(v + '\FormDesign', FALSE) then begin
   x:= r.Readstring('DefaultFont');
   SetObjects (x);
   r.CloseKey;
  end;
 finally
  r.Free;
 end;
end (*ReadFromReg*);

PROCEDURE TForm1.FormShow(Sender: TObject);
var path, x, y: string;
    i, j: INTEGER;
    r: TRegistry;

 function ReadKey (s: string; var p: string): Boolean;
 begin
  Result:= false;
  if r.OpenKeyReadOnly (s) then begin
   p:= s;
   Result:= true;
   r.CloseKey;
  end;
 end;

begin
 Label3.Caption:= 'Compiled: ' + _CompileDateTime_;
 p5:= '';
 p4:= '';
 p3:= '';
 p2:= '';
 r := TRegistry.Create;
 try
  r.Rootkey:= HKEY_CURRENT_USER;
  // Looking, which Delphi is present
  Delphi2.Enabled:= ReadKey (cpath + '2.0', p2);
  Delphi3.Enabled:= ReadKey (cpath + '3.0', p3);
  Delphi4.Enabled:= ReadKey (cpath + '4.0', p4);
  Delphi5.Enabled:= ReadKey (cpath + '5.0', p5);
  if p2 <> '' then begin  path:= p2;  Delphi2.Checked:= TRUE;  end;
  if p3 <> '' then begin  path:= p3;  Delphi3.Checked:= TRUE;  end;
  if p4 <> '' then begin  path:= p4;  Delphi4.Checked:= TRUE;  end;
  if p5 <> '' then begin  path:= p4;  Delphi5.Checked:= TRUE;  end;
 finally
  r.Free;
 end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var path, x: string;
    r: TRegistry;
begin
 r:= TRegistry.Create;
 try
  r.Rootkey:= HKEY_CURRENT_USER;
  if Delphi2.Checked then path := cpath + '2.0\FormDesign';
  if Delphi3.Checked then path := cpath + '3.0\FormDesign';
  if Delphi4.Checked then path := cpath + '4.0\FormDesign';
  if Delphi5.Checked then path := cpath + '5.0\FormDesign';
  if r.OpenKey(path, TRUE) then begin
   x:= FontComboBox1.FontName + ', ';
   x:= x + IntToStr (RxSpinEdit1.AsInteger);
   if Fett.Checked then  x:= x + ', bold';
   if Kursiv.Checked then  x:= x + ', italic';
   r.Writestring ('DefaultFont', x);
   r.CloseKey;
  end;
 finally
  r.Free;
 end;
end;

procedure TForm1.Label2Click(Sender: TObject);
begin
 // Send a mail to me
 Label2.Font.Color:= clPurple;
 Label2.Update;
 ShellExecute (Application.Handle,
               'open', PChar ('mailto:'+ Label2.Caption),
               nil, nil, SW_SHOWNORMAL);
 Label2.Font.Color:= clBlue;
end;

procedure TForm1.Delphi2Click(Sender: TObject);
begin
 ReadFromReg (p2);
end;

procedure TForm1.Delphi3Click(Sender: TObject);
begin
 ReadFromReg (p3);
end;

procedure TForm1.Delphi4Click(Sender: TObject);
begin
 ReadFromReg (p4);
end;

procedure TForm1.Delphi5Click(Sender: TObject);
begin
 ReadFromReg (p5);
end;

end.
